local M  = {}

local function setFreeCameraAdvanced(params)
  local cam = commands.getFreeCamera()
  if not cam then return end
  params = params or {}

  cam:setFlyMode()
  cam.newtonMode = params.smoothPos
  cam.newtonRotation = params.smoothRot
  cam.angularForce = params.angularForce or 100
  cam.angularDrag = params.angularDrag or 2
  cam.mass = params.mass or 10
  cam.drag = params.drag or 2
  cam.force = params.force or 500
  cam:setAngularVelocity(Point3F(0, 0, 0))

  local pos = getCameraTransform()
  cam:setTransform(pos)
  GameConnection.setCamera(cam.obj)
end

M.setFreeCameraAdvanced = setFreeCameraAdvanced

return M