angular.module('beamng.apps')
.directive('freeCamTool', ['$filter', '$log', function ($filter, $log) {
  return {
    templateUrl: '/ui/modules/apps/FreeCamTool/app.html',
    replace: false,
    restrict: 'E',
    scope: true,
    link: function (scope, element, attrs) {
      scope.camSpeed = 50;
      scope.isFreeCam = false;
      scope.smoothPos = false;
      scope.smoothRot = false;
      
      scope.buttonElem = angular.element(element[0].querySelector('.md-button'));
      scope.sliderElem = angular.element(element[0].querySelector('.slider'));
      
      scope.updateFreeCam = function () {
        if (scope.isFreeCam) {
          scope.buttonElem.addClass('active');
          bngApi.engineLua('extensions.core_freeCamHelper.setFreeCameraAdvanced(' + bngApi.serializeToLua({smoothPos: scope.smoothPos, smoothRot: scope.smoothRot}) + ')');
        }
      }
      
      scope.toggleCam = function () {
        scope.isFreeCam = !scope.isFreeCam;

        if (scope.isFreeCam) {
          scope.updateFreeCam();
          bngApi.engineLua('ui_message("Camera mode: Free camera", 3, "freeCamTool", "camera")');
        } else {
          scope.buttonElem.removeClass('active');
          bngApi.engineLua('commands.setGameCamera()');
          bngApi.engineLua('ui_message("Camera mode: Game camera", 3, "freeCamTool", "camera")');
        }
      }

      scope.setCamSpeed = function () {
        bngApi.engineScript('$Camera::movementSpeed = ' + scope.camSpeed + ';');
        //bngApi.engineLua('extensions.core_freeCamHelper.setCameraSpeed(' + scope.camSpeed + ')');
      }
      
      var moveSlider = function (event) {
        var value = event.preset || Math.max(0, Math.min(120, event.pageX - scope.sliderElem[0].getBoundingClientRect().left));
        scope.sliderElem[0].querySelector('.sliderCtrl').style.left = (value - 4) + 'px';
        scope.sliderElem[0].querySelector('.sliderBar').style.width = value + 'px';
        scope.camSpeed = value;
        scope.setCamSpeed();
      }
      moveSlider({preset: 50});
      
      scope.sliderElem[0].addEventListener('mousedown', function () {
        scope.sliderElem[0].addEventListener('mousemove', moveSlider);
      });
      
      scope.sliderElem[0].addEventListener('mouseup', function () {
        scope.sliderElem[0].removeEventListener('mousemove', moveSlider);
      });
    }
  };
}]);